/*
UDPͨųĻϽʾ
ɼ򵥵RTPͷ겢ͨUDPЭ鷢͡յĹ̡
ӵʱҪ⣺ws2_32.lib 

Multimedia Communications Lab
University of Science & Technology
network@ustc.edu.cn
*/

#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>//doubleʱýͷļϣȷԭ

//ʾϸRTPݱϢݽʱ̵ʱ㶶
#define DETAIL_PRINT
//ʾϸRTPݱϢоݱǷ
#define NORMAL_PRINT
//ʾݱľݣڹ۲ʵʽյЧ
//ע⣺SIMPLE_PRINTNORMAL_PRINTͬʱ
//#define SIMPLE_PRINT

//ĲƵʣڱнǸݷַ
//ĳȼÿ跢͵ֽ
//ע⣺ķǲһģ
//1ÿ20msһݱ2ÿ10msһݱ
#define STREAM_1_SAMPLE_FREQ 500.0/1000.0
#define STREAM_2_SAMPLE_FREQ 500.0/1000.0

//Ҫݽṹ-begin
/* Type sizes */
typedef unsigned long int u_int32;
typedef unsigned short int u_int16;
typedef unsigned char u_int8;
// 32-bit sequence number
typedef u_int16 RtpSeqNumber;
// Middle 32-bit of NTP
typedef u_int32 RtpTime;
// 32-bit source number
typedef u_int32 RtpSrc;

// RTP packet header
struct RtpHeaderStruct
{
	u_int32 version : 2;	// protocal version
	u_int32 padding : 1;	// padding flag - for encryption
    u_int32 extension : 1;	// header extension flag
    u_int32 count : 4;		// csrc count
    u_int32 marker : 1;		// marker bit - for profile
    u_int32 type : 7;		// payload type
    u_int32 sequence : 16;	// sequence number of this packet
    RtpTime timestamp;		// timestamp of this packet
    RtpSrc ssrc;			// source of packet
    RtpSrc startOfCsrc;		// list of contributing sources
};
typedef struct RtpHeaderStruct RTP_HEADER;

// RTCP header
struct RtcpHeaderStruct
{
	u_int32 version : 2;	// protocal version
    u_int32 padding : 1;	// padding flag
    u_int32 count : 5;		// depending on packet type
    u_int32 type : 8;		// type of RTCP packet
    u_int32 length : 16;	// lenght of RTCP packet in octlets minus 1
};
typedef struct RtcpHeaderStruct RTCP_HEADER;
//Ҫݽṹ-end

//ȫֱݱʱɵʱ
//ʶÿݰʱ˴ΪݱֽڵĿ
//Ƕ12ȡƵʵĶ֪
//1ݱ֮ʱֵΪ10
//2ݱ֮ʱֵΪ5
//˴ʱͷͳжʱλͬռ
RtpTime rtp_timestamp_1 = 0 , rtp_timestamp_2 = 0;
RtpTime last_rtp_timestamp_1 = 0,last_rtp_timestamp_2=0;
//ϵͳʱƵ
double dfFreq = 0; 
//ڴϵͳʱйϢȫֱ
LARGE_INTEGER liTime; 
//ÿݱյʱϵͳʱ
double rtp_sampletime_1 = 0.0 , rtp_sampletime_2 = 0.0;
//ͬԴʶ飬ʾнʵ2Ĵ䣬
RtpSrc ssrc_array[2] = {0};
//ݱķʱ͵ʱĲֵ
/*
   If Si is the RTP timestamp from packet i, and Ri is the time of
   arrival in RTP timestamp units for packet i, then for two packets i
   and j, D may be expressed as

                 D(i,j)=(Rj-Ri)-(Sj-Si)=(Rj-Sj)-(Ri-Si)
*/
//Ķ
unsigned long delay_packet_1 = 0,delay_packet_2 = 0;
/*
   The interarrival jitter is calculated continuously as each data
   packet i is received from source SSRC_n, using this difference D for
   that packet and the previous packet i-1 in order of arrival (not
   necessarily in sequence), according to the formula

                    J=J+(|D(i-1,i)|-J)/16
*/
double jitter_stream_1=0.0 , jitter_stream_2=0.0;


//ݽյݽRTPͷꡢʾݾݡ㶶ֱͬ
void DecodeRtpHeaderDetails(char *RecvBuf)
{
	char *szMessage;
	RTP_HEADER *rtp_header;
	rtp_header = (RTP_HEADER*)RecvBuf;
	szMessage = RecvBuf + sizeof(RTP_HEADER);
	printf("\"%s\" received \n", szMessage);
	printf("\trtp_header->version = %u\n",rtp_header->version);
	printf("\trtp_header->padding = %u\n",rtp_header->padding);
	printf("\trtp_header->extension = %u\n",rtp_header->extension);
	printf("\trtp_header->count = %u\n",rtp_header->count);
	printf("\trtp_header->marker = %u\n",rtp_header->marker);
	printf("\trtp_header->type = %u\n",rtp_header->type);
	printf("\trtp_header->sequence = %u\n",rtp_header->sequence);
	printf("\trtp_header->timestamp = %u\n",rtp_header->timestamp);
	printf("\trtp_header->ssrc = %u\n",rtp_header->ssrc);
#ifdef DETAIL_PRINT
	//ͬԴʶжݱǸ
	if(ssrc_array[0] == 0)
	{ 
		if(ssrc_array[1] == 0)//һνݽ
		{
			ssrc_array[0] = rtp_header->ssrc;
		}
	}
	else
	{
		if(ssrc_array[1] == 0)//һνssrc_array[1]ʾݱ
		{
			ssrc_array[1] = rtp_header->ssrc;
		}
	}
	if(ssrc_array[0] == rtp_header->ssrc) //ssrc_array[0]ʾݱ
	{
		//ȡǰϵͳʱƵϢ
		QueryPerformanceCounter(&liTime); 
		//ʱ̵ʱ
		rtp_timestamp_1 = rtp_timestamp_1 
			+ floor( (liTime.QuadPart*1000.0 - rtp_sampletime_1) / dfFreq * 0.5);
		//¼ǰʱ̵ʱƵϢ
		rtp_sampletime_1 = liTime.QuadPart*1000.0;
		//㶶
		if(delay_packet_1!=0)
		{
			jitter_stream_1 = abs(jitter_stream_1 
				+ abs( abs(rtp_timestamp_1 - rtp_header->timestamp) - delay_packet_1))*0.0625;
		}
		printf("\tReceived rtp timestamp_1:%u\n",rtp_timestamp_1);
		printf("\tDelay_1:%u\n",delay_packet_1);
		printf("\tjitter_1:%f\n",jitter_stream_1);
		delay_packet_1 = abs(rtp_timestamp_1 - rtp_header->timestamp);
	}
	if(ssrc_array[1] == rtp_header->ssrc) //ssrc_array[1]ʾݱ
	{
		//ȡǰϵͳʱƵϢ
		QueryPerformanceCounter(&liTime); 
		//ʱ̵ʱ
		rtp_timestamp_2 = rtp_timestamp_2 
			+ floor( (liTime.QuadPart*1000.0 - rtp_sampletime_2) / dfFreq * 0.5);
		//¼ǰʱ̵ʱƵϢ
		rtp_sampletime_2 = liTime.QuadPart*1000.0;
		//㶶
		if(delay_packet_2!=0)
		{
			jitter_stream_2 = abs(jitter_stream_2 
				+ abs( abs(rtp_timestamp_2 - rtp_header->timestamp) - delay_packet_2))*0.0625;
		}
		printf("\tReceived rtp timestamp_2:%u\n",rtp_timestamp_2);
		printf("\tDelay_2:%u\n",delay_packet_2);
		printf("\tjitter_2:%f\n",jitter_stream_2);
		delay_packet_2 = abs(rtp_timestamp_2 - rtp_header->timestamp);
	}
#endif
	return;
}

//ݽյݲʾݾ
void DecodeRtpHeaderSimple(char *RecvBuf)
{
	char *szMessage;
	szMessage = RecvBuf + sizeof(RTP_HEADER);
	printf(szMessage);
	return;
}

int main(int argc, int **argv)
{
	WSADATA wsda;
	char RecvBuf[64];
	int iMessageLen;
	int ret;
	unsigned short iPort;
	SOCKET s;					// Our TCP socket handle
	SOCKADDR_IN addr,			// The local interface address
               remote_addr;		// The sender's address
	int iRemoteAddrLen;			// Contains the length of remte_addr, passed to recvfrom
	//ڿƳʱ
	DWORD timeout = 10000;
	DWORD start = GetTickCount();
	int PacketReceived = 0;

	srand( (unsigned)time( NULL ) );
	//ʱʼֵ
	rtp_timestamp_1 = rand();
	rtp_timestamp_2 = rand();
	//ȡϵͳʱƵ,ʱƵʽڼʱ
	QueryPerformanceFrequency(&liTime); 
	dfFreq = (double)liTime.QuadPart; 
	ssrc_array[0] = 0;
	ssrc_array[1] = 0;

	//в
	if(argc != 2 ||
		(argc==2 && strcmp((char *) &argv[1][0], "/?")==0))
	{
		printf("wsudprcv port\n");
		printf("   port:   the port the server should listen to\n");
		exit(1);
	}
	
	//ȡвеĶ˿ںϢ
	iPort = atoi((char *) &argv[1][0]);
	if(iPort<0 || iPort>65563)
	{
		printf("Invalid port number! (%s)\n", argv[2]);
		exit(1);
	}
	
	//ʼWinsock
	WSAStartup(MAKEWORD(1,1), &wsda);
	//һUDP socket
	printf("Creating socket...");
	s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	//
	if(s == SOCKET_ERROR)
	{
		printf("Error\nCall to socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP); failed with:\n%d\n", WSAGetLastError());
		exit(1);
		
	}
	printf("OK\n");
	// Fill in the interface information
	printf("Binding socket...");
	addr.sin_family = AF_INET;
	addr.sin_port = htons(iPort);
	addr.sin_addr.s_addr = INADDR_ANY;
	if(bind(s, (struct sockaddr *) &addr, sizeof(addr)) == SOCKET_ERROR)
	{
		printf("Error\nCall to bind(s, (struct sockaddr *) &addr, sizeof(addr)); failed with:\n%d\n", WSAGetLastError());
		exit(1);
	}
	printf("OK\n");
//ҪڳִеĹʾRTPݱͷϢҪļͷDETAIL_PRINT	
#ifdef NORMAL_PRINT
	//10ӵĽյȴʱ
	while(1)
	{
		//ʱ,10sʱ
		if((GetTickCount() - start) >= timeout) break;
		iMessageLen = 64;
		//PacketReceived¼յ
		PacketReceived++;
		// ׼ݱĸ
		printf("Waiting for packets (Press Ctrl-C to exit)...\n");
		iRemoteAddrLen = sizeof(remote_addr);
		ret = recvfrom(s, RecvBuf, iMessageLen, 0, (struct sockaddr *) &remote_addr, &iRemoteAddrLen);
		if(ret == SOCKET_ERROR)
		{
			printf("Error\nCall to recvfrom(s, RecvBuf, iMessageLen, 0, (struct sockaddr *) &remote_addr, &iRemoteAddrLen); failed with:\n%d\n", WSAGetLastError());
			exit(1);
		}
		iMessageLen = ret;		// Length of the data received
		RecvBuf[iMessageLen] = '\0';		// Convert to cstring
		printf("Packet Length = %d; Packet From : %s\n",iMessageLen,inet_ntoa(remote_addr.sin_addr));
		DecodeRtpHeaderDetails(RecvBuf);
		printf("Total Packet Received:%d\n",PacketReceived);
	}
#endif
//ҪʾRTPݱϢʾݣҪļͷSIMPLE_PRINT
#ifdef SIMPLE_PRINT
	printf("Waiting for packets (Press Ctrl-C to exit)...\n");
	//10ӵĽյȴʱ
	while(1)
	{
		//ʱ,10sʱ
		if((GetTickCount() - start) >= timeout) break;
		iMessageLen = 64;
		//PacketReceived¼յ
		PacketReceived++;
		// ׼ݱĸ
		iRemoteAddrLen = sizeof(remote_addr);
		ret = recvfrom(s, RecvBuf, iMessageLen, 0, (struct sockaddr *) &remote_addr, &iRemoteAddrLen);
		if(ret == SOCKET_ERROR)
		{
			printf("Error\nCall to recvfrom(s, RecvBuf, iMessageLen, 0, (struct sockaddr *) &remote_addr, &iRemoteAddrLen); failed with:\n%d\n", WSAGetLastError());
			exit(1);
		}
		iMessageLen = ret;		// Length of the data received
		RecvBuf[iMessageLen] = '\0';		// Convert to cstring
		DecodeRtpHeaderSimple(RecvBuf);
	}
		printf("Total Packet Received:%d\n",PacketReceived);
#endif
	closesocket(s);
	WSACleanup();
	return 0;
}
